#include "DecodePolynome.h"

// transforme une chaine de caracteres en entier [pas d'espaces parasites ici]
int str2Int(std::string s) {
	int res=0;
	for (int i=0; i<(int)s.size(); i++) {
		if (s[i]-'0'>=0 && s[i]-'0'<=9) res=s[i]-'0'+10*res;
		else break;
	}
	return res;
}

// transforme une chaine de caracteres en polynome;
// etapes suivantes: eventuellement verifier la syntaxe, et autoriser les ecritures en X,Y,Z,T.. puis
// autoriser certains espaces parasites (evt. sauf entre X^ et k, et a la fin)
PolPlusVarGrevlex str2PolGrevlex(std::string s) {

	if (s.empty()) return PolPlusVarGrevlex();

	// 1er parcours pour determiner n
	std::string::iterator it;
	std::vector<int> exposants;
	for (int i=0; i<(int)s.size(); i++)
		if (s[i]=='X' && i<(int)s.size()-1) {
			it=s.begin();
			for (int j=0; j<=i; j++) it++;
			std::string tmp=std::string(it,s.end());
			exposants.push_back(str2Int(tmp));
		}

	// calcul du maximum==n
	int n;
	if (exposants.empty()) n=1;
	else {
		int best=exposants[exposants.size()-1];
		for (int i=exposants.size()-2; i>=0; i--)
			if (exposants[i]>best) best=exposants[i];
		n=best;
	}

	bool x[n]; // indique si X1,X2..etc ont ete traites
	for (int i=n-1; i>=0; i--) x[i]=false;
	char pred='+',cour; // caracteres precedents et courants
	TermGrevlex term=TermGrevlex(n);
	PolPlusVarGrevlex pol=PolPlusVarGrevlex();
	int i=0;

	// on lit les caracteres un par un
	while  (i<(int)s.size()) {

		// un petit travail reste a faire pour associer 'A' a X1..etc
		// 'A'==X1, 'B'==X2..etc (donc pas plus de 23 variables, ca doit etre suffisant!)
		if (s[i]=='X' && i<(int)s.size()-1) {
			// recuperation du nombre derriere X
			it=s.begin();
			for (int j=0; j<=i; j++) it++;
			std::string tmp=std::string(it,s.end());
			cour=(char)('A'+str2Int(tmp)-1);
		}
		else cour=s[i];

		if (cour=='+' || cour=='-') {
			// addition/soustraction: on acheve le terme en cours, et on l'ajoute au polynome
			if (pred=='#') {
				if (term.getCoeff()!=0) {
					for (int j=0; j<n; j++) term.addElt(0);
					pol.addTerm(term);
				}
			}
			else if ((int)(pred-'A')>=0 && (int)(pred-'X')<0) {
				if (term.getCoeff()!=0) {
					for (int j=0; j<(int)(pred-'A'); j++)
						if (!x[j]) term.addElt(0);
					if (!x[(int)(pred-'A')]) term.addElt(1);
					for (int j=(int)(pred-'B'); j<n; j++)
						if (!x[j]) term.addElt(0);
					pol.addTerm(term);
				}
			}
			for (int j=n-1; j>=0; j--) x[j]=false;
			term=TermGrevlex(n);
			pred=cour;
			i++;
		}
		// dans le cas de la multiplication: on ne fait rien, on regarde juste l'indeterminee suivante

		else if ((int)(cour-'A')>=0 && (int)(cour-'X')<0) {
			// cas d'une indeterminee: il suffit d'ignorer les chiffres qui suivent
			if (pred=='+') term.setCoeff(1);
			else if (pred=='-') term.setCoeff(-1);
			pred=cour;

			// on complete les exposants des indeterminees inferieures s'il y a lieu
			for (int j=0; j<(int)(cour-'A'); j++)
				if (!x[j]) {
					term.addElt(0);
					x[j]=true;
				}

			// on se positionne sur le premier caractere qui suit qui n'est pas un entier (attention!)
			// s'il y a un exposant ce sera '^', sinon un signe + , * ou - , voir rien (EOF, re-attention!)
			i++;
			while ((int)(s[i]-'0')>=0 && (int)(s[i]-'9')<=0) i++;
			if (i>=(int)s.size() && term.getCoeff()!=0) {
				term.addElt(1);
				for (int j=(int)(cour-'B'); j<n; j++) term.addElt(0);
				pol.addTerm(term);
				break;
			}
			else if (s[i]=='*') {
				term.addElt(1);
				x[(int)(cour-'A')]=true;
			}
		}

		else if (cour=='^') {
			// on lit l'exposant
			it=s.begin();
			for (int j=0; j<=i; j++) it++;
			term.addElt(str2Int(std::string(it,s.end())));
			x[(int)(pred-'A')]=true;

			// on se place juste apres le dernier chiffre
			i++;
			while ((int)(s[i]-'0')>=0 && (int)(s[i]-'9')<=0) i++;
			if (i>=(int)s.size() && term.getCoeff()!=0) {
				for (int j=(int)(pred-'B'); j<n; j++)
					if (!x[j]) term.addElt(0);
				pol.addTerm(term);
				break;
			}
		}

		else if (cour-'0'>=0 && cour-'0'<=9) { // c'est forcement un coefficient; les puissances sont traitees plus haut
			// on lit le coefficient
			it=s.begin();
			for (int j=0; j<i; j++) it++;
			std::string tmp=std::string(it,s.end());
			if (pred=='+') term.setCoeff(str2Int(tmp));
			else if (pred=='-') term.setCoeff(-str2Int(tmp));
			if (i==(int)s.size()-1 && term.getCoeff()!=0) {
				for (int j=n-1; j>=0; j--) term.addElt(0);
				pol.addTerm(term);
				break;
			}

			// on se place juste apres le dernier chiffre
			while ((int)(s[i]-'0')>=0 && (int)(s[i]-'9')<=0) i++;
			if (i>=(int)s.size() && term.getCoeff()!=0) {
				for (int j=0; j<n; j++) term.addElt(0);
				pol.addTerm(term);
				break;
			}
			pred='#'; // signifie qu'on vient de lire un coefficient
		}

		else i++; // cas d'une multiplication
	}

	// on trie le polynome via un sort a la fin du decodage
	pol.tri();
	return pol;
}

// ordre lex
PolPlusVarLex str2PolLex(std::string s) {

	if (s.empty()) return PolPlusVarLex();

	// 1er parcours pour determiner n
	std::string::iterator it;
	std::vector<int> exposants;
	for (int i=0; i<(int)s.size(); i++)
		if (s[i]=='X' && i<(int)s.size()-1) {
			it=s.begin();
			for (int j=0; j<=i; j++) it++;
			std::string tmp=std::string(it,s.end());
			exposants.push_back(str2Int(tmp));
		}

	// calcul du maximum==n
	int n;
	if (exposants.empty()) n=1;
	else {
		int best=exposants[exposants.size()-1];
		for (int i=exposants.size()-2; i>=0; i--)
			if (exposants[i]>best) best=exposants[i];
		n=best;
	}

	bool x[n]; // indique si X1,X2..etc ont ete traites
	for (int i=n-1; i>=0; i--) x[i]=false;
	char pred='+',cour; // caracteres precedents et courants
	TermLex term=TermLex(n);
	PolPlusVarLex pol=PolPlusVarLex();
	int i=0;

	// on lit les caracteres un par un
	while  (i<(int)s.size()) {

		// un petit travail reste a faire pour associer 'A' a X1..etc
		// 'A'==X1, 'B'==X2..etc (donc pas plus de 23 variables, ca doit etre suffisant!)
		if (s[i]=='X' && i<(int)s.size()-1) {
			// recuperation du nombre derriere X
			it=s.begin();
			for (int j=0; j<=i; j++) it++;
			std::string tmp=std::string(it,s.end());
			cour=(char)('A'+str2Int(tmp)-1);
		}
		else cour=s[i];

		if (cour=='+' || cour=='-') {
			// addition/soustraction: on acheve le terme en cours, et on l'ajoute au polynome
			if (pred=='#') {
				if (term.getCoeff()!=0) {
					for (int j=0; j<n; j++) term.addElt(0);
					pol.addTerm(term);
				}
			}
			else if ((int)(pred-'A')>=0 && (int)(pred-'X')<0) {
				if (term.getCoeff()!=0) {
					for (int j=0; j<(int)(pred-'A'); j++)
						if (!x[j]) term.addElt(0);
					if (!x[(int)(pred-'A')]) term.addElt(1);
					for (int j=(int)(pred-'B'); j<n; j++)
						if (!x[j]) term.addElt(0);
					pol.addTerm(term);
				}
			}
			for (int j=n-1; j>=0; j--) x[j]=false;
			term=TermLex(n);
			pred=cour;
			i++;
		}
		// dans le cas de la multiplication: on ne fait rien, on regarde juste l'indeterminee suivante

		else if ((int)(cour-'A')>=0 && (int)(cour-'X')<0) {
			// cas d'une indeterminee: il suffit d'ignorer les chiffres qui suivent
			if (pred=='+') term.setCoeff(1);
			else if (pred=='-') term.setCoeff(-1);
			pred=cour;

			// on complete les exposants des indeterminees inferieures s'il y a lieu
			for (int j=0; j<(int)(cour-'A'); j++)
				if (!x[j]) {
					term.addElt(0);
					x[j]=true;
				}

			// on se positionne sur le premier caractere qui suit qui n'est pas un entier (attention!)
			// s'il y a un exposant ce sera '^', sinon un signe + , * ou - , voir rien (EOF, re-attention!)
			i++;
			while ((int)(s[i]-'0')>=0 && (int)(s[i]-'9')<=0) i++;
			if (i>=(int)s.size() && term.getCoeff()!=0) {
				term.addElt(1);
				for (int j=(int)(cour-'B'); j<n; j++) term.addElt(0);
				pol.addTerm(term);
				break;
			}
			else if (s[i]=='*') {
				term.addElt(1);
				x[(int)(cour-'A')]=true;
			}
		}

		else if (cour=='^') {
			// on lit l'exposant
			it=s.begin();
			for (int j=0; j<=i; j++) it++;
			term.addElt(str2Int(std::string(it,s.end())));
			x[(int)(pred-'A')]=true;

			// on se place juste apres le dernier chiffre
			i++;
			while ((int)(s[i]-'0')>=0 && (int)(s[i]-'9')<=0) i++;
			if (i>=(int)s.size() && term.getCoeff()!=0) {
				for (int j=(int)(pred-'B'); j<n; j++)
					if (!x[j]) term.addElt(0);
				pol.addTerm(term);
				break;
			}
		}

		else if (cour-'0'>=0 && cour-'0'<=9) { // c'est forcement un coefficient; les puissances sont traitees plus haut
			// on lit le coefficient
			it=s.begin();
			for (int j=0; j<i; j++) it++;
			std::string tmp=std::string(it,s.end());
			if (pred=='+') term.setCoeff(str2Int(tmp));
			else if (pred=='-') term.setCoeff(-str2Int(tmp));
			if (i==(int)s.size()-1 && term.getCoeff()!=0) {
				for (int j=n-1; j>=0; j--) term.addElt(0);
				pol.addTerm(term);
				break;
			}

			// on se place juste apres le dernier chiffre
			while ((int)(s[i]-'0')>=0 && (int)(s[i]-'9')<=0) i++;
			if (i>=(int)s.size() && term.getCoeff()!=0) {
				for (int j=0; j<n; j++) term.addElt(0);
				pol.addTerm(term);
				break;
			}
			pred='#'; // signifie qu'on vient de lire un coefficient
		}

		else i++; // cas d'une multiplication
	}

	// on trie le polynome via un sort a la fin du decodage
	pol.tri();
	return pol;
}

// met un ensemble de polynomes au meme nombre de termes
std::vector<PolPlusVarGrevlex> normaliseGrevlex(const std::vector<PolPlusVarGrevlex>& tabPol) {
	int n=0;
	// a) calcul de n=max nb indet
	for (int i=(int)tabPol.size()-1; i>=0; i--)
		if ((int)tabPol[i].getSize()>0 && (int)tabPol[i][0].getSize()>n) n=(int)tabPol[i][0].getSize();

	// b) mise a jour
	std::vector<PolPlusVarGrevlex> res;
	for (int i=0; i<(int)tabPol.size(); i++) {
		if ((int)tabPol[i].getSize()>0) {
			PolPlusVarGrevlex pol=PolPlusVarGrevlex();
			for (int j=0; j<tabPol[i].getSize(); j++) {
				TermGrevlex term=TermGrevlex(n);
				term.setCoeff(tabPol[i][j].getCoeff());
				for (int k=0; k<tabPol[i][0].getSize(); k++)
					term.addElt(tabPol[i][j][k]);
				for (int k=tabPol[i][0].getSize(); k<n; k++)
					term.addElt(0);
				pol.addTerm(term);
			}
			res.push_back(pol);
		}
	}
	return res;
}

std::vector<PolPlusVarLex> normaliseLex(const std::vector<PolPlusVarLex>& tabPol) {
	int n=0;
	// a) calcul de n=max nb indet
	for (int i=(int)tabPol.size()-1; i>=0; i--)
		if ((int)tabPol[i].getSize()>0 && (int)tabPol[i][0].getSize()>n) n=(int)tabPol[i][0].getSize();

	// b) mise a jour
	std::vector<PolPlusVarLex> res;
	for (int i=0; i<(int)tabPol.size(); i++) {
		if ((int)tabPol[i].getSize()>0) {
			PolPlusVarLex pol=PolPlusVarLex();
			for (int j=0; j<tabPol[i].getSize(); j++) {
				TermLex term=TermLex(n);
				term.setCoeff(tabPol[i][j].getCoeff());
				for (int k=0; k<tabPol[i][0].getSize(); k++)
					term.addElt(tabPol[i][j][k]);
				for (int k=tabPol[i][0].getSize(); k<n; k++)
					term.addElt(0);
				pol.addTerm(term);
			}
			res.push_back(pol);
		}
	}
	return res;
}

// permet de lire des polynomes dans un fichier
std::vector<PolPlusVarGrevlex> readFileGrevlex(char* name) {
	std::vector<PolPlusVarGrevlex> tabPol;
	std::ifstream file(name);
	std::string polynome;
	while (getline(file,polynome,'\n')) {
		// on supprime les espaces dans la ligne si necessaire
		std::string::iterator it=polynome.begin();
		int i=0;
		for (; i<(int)polynome.size() && polynome[i]!=' '; i++) it++;
		if (i<(int)polynome.size()) polynome.erase(it,polynome.end());
		// on empile alors le polynome
		tabPol.push_back(str2PolGrevlex(polynome));
	}
	return tabPol;
}

std::vector<PolPlusVarLex> readFileLex(char* name) {
	std::vector<PolPlusVarLex> tabPol;
	std::ifstream file(name);
	std::string polynome;
	while (getline(file,polynome,'\n')) {
		// on supprime les espaces dans la ligne si necessaire
		std::string::iterator it=polynome.begin();
		int i=0;
		for (; i<(int)polynome.size() && polynome[i]!=' '; i++) it++;
		if (i<(int)polynome.size()) polynome.erase(it,polynome.end());
		// on empile alors le polynome
		tabPol.push_back(str2PolLex(polynome));
	}
	return tabPol;
}
