/* classe pour transformer une chaine de caracteres entree au clavier en
polynome */

#ifndef _DecodePolynome
#define _DecodePolynome

#include <iostream>
#include <fstream>

#include "Fp.h"
#include "TermGrevlex.h"
#include "TermLex.h"
#include "PolPlusVarGrevlex.h"
#include "PolPlusVarLex.h"

class DecodePolynome {};

// transforme une chaine de caracteres en entier [pas d'espaces parasites ici]
extern int str2Int(std::string s);

// transforme une chaine de caracteres en polynome, pour grevlex et lex respectivement
extern PolPlusVarGrevlex str2PolGrevlex(std::string s);
extern PolPlusVarLex str2PolLex(std::string s);

// met un ensemble de polynomes au meme nombre de termes
extern std::vector<PolPlusVarGrevlex> normaliseGrevlex(const std::vector<PolPlusVarGrevlex>& tabPol);
extern std::vector<PolPlusVarLex> normaliseLex(const std::vector<PolPlusVarLex>& tabPol);

// permet de lire des polynomes dans un fichier
extern std::vector<PolPlusVarGrevlex> readFileGrevlex(char* name);
extern std::vector<PolPlusVarLex> readFileLex(char* name);

#endif
