#include <iostream>
#include "Fp.h"
#include <cmath>
#include <cstdlib>

Fp::Fp(int x) {
	p=101; // valeur modulable
	if (x>=0) value=x%p;
	else {
		int tmp=x;
		while (tmp<0) tmp+=p;
		value=tmp;
	}
}

// inversion modulaire
int Fp::invMod() const {
	// on applique l'algorithme d'Euclide pour trouver une relation xu+pv=1; alors x^-1=u%p
	int a1=0,a2=1,a3=1,a4=p/value; // les coefficients actualises de la matrice
	int q=value,r=abs(p%value); // quotients et restes
	int aux,aux2; // variables temporaires
	while (r>0) {
		a1=a3;
		aux2=a2;
		a2=a4;
		a3*=-a4;
		a4=aux2+a4*(q/r);
		aux=q%r;
		q=r;
		r=abs(aux);
	}
	if (a3<0) return -a2+p;
	return a2;
}

// affichage
std::ostream& operator<<(std::ostream& o, const Fp& x) {
	o << x.getValue();
	return o;
}
