#include "ResolSystFp.h"
#include <iostream>

// etendre au cas de systemes quelconques, donc traiter les groupes d'equations manquantes:
// s'il manque un groupe, appeler la recherche de solution sur toutes les valeurs possibles de l'indeterminee!

// methode d'affichage des solutions
void ResolSystFp::affiche() {
	std::cout << "Ensemble des solutions:" << std::endl;
	for (int i=0; i<(int)tabSol.size(); i++) {
		for (int j=(int)tabSol[i].size()-1; j>=1; j--)
			std::cout << tabSol[i][j] << ", ";
		std::cout << tabSol[i][0] << std::endl;
	}
}

void ResolSystFp::solveRec(const std::vector<Gen>& solCour, int indice) {

	if (indice>=n) {
		tabSol.push_back(solCour);
		return;
	}

	// dans le cas ou le groupe est present, pas de problemes
	if (equations[n-indice-1].size()>0) {

		// a) on calcul le pgcd qui nous interesse
		PolPlusVarLex gcd_pol,aux;
		gcd_pol=PolPlusVarLex(equations[n-indice-1][equations[n-indice-1].size()-1]);

		// substitution dans la derniere equation du groupe n-indice-1
		for (int k=indice-1; k>=0; k--) {
			gcd_pol=gcd_pol.subsFp(solCour[k].getValue(),n-k-1);
		}

		for (int j=equations[n-indice-1].size()-2; j>=0; j--) {
			aux=PolPlusVarLex(equations[n-indice-1][j]);
			// substitution dans la j-ieme equation du groupe n-indice-1
			for (int k=indice-1; k>=0; k--) {
				aux=aux.subsFp(solCour[k].getValue(),n-k-1);
			}
			gcd_pol=gcd_pol.pgcd(aux);
		}

		// b) on resout
		int p=equations[0][0][0].getCoeff().getP();

		// amelioration possible: tester le degre de l'equation
		for (int i=p-1; i>=0; i--) {
			aux=gcd_pol.subsFp(i,n-indice-1);
			if (aux.getSize()==0) {
				std::vector<Gen> sol=solCour;
				sol.push_back(Gen(i));
				solveRec(sol,indice+1);
			}
		}
	}
	// sinon, il faut essayer toutes les valeurs de l'indeterminee (tres couteux en temps de calcul)
	else {
		int p=equations[0][0][0].getCoeff().getP();
		for (int i=p-1; i>=0; i--) {
			std::vector<Gen> sol=solCour;
			sol.push_back(i);
			solveRec(sol,indice+1);
		}
	}
}
