#ifndef _ResolSystFp
#define _ResolSystFp

#include "Fp.h"
#include "TermLex.h"
#include "PolPlusVarLex.h"
#include "DecodePolynome.h"
#include "AlgoClassiquesLex.h"
#include <vector>

// type d'une solution
typedef std::vector<Gen> solution;

class ResolSystFp {

public:

	// constructeur vide
	ResolSystFp() {}

	// constructeur
	ResolSystFp(std::vector<PolPlusVarLex> eq[]) {
		equations=eq;
		n=eq[0][0][0].getSize();
	}

	// methode d'affichage des solutions
	void affiche();

	// fonction principale de resolution
	void solve() {
		std::vector<Gen> initialisation;
		solveRec(initialisation,0);
	}

	// fonction recursive de resolution; analogue d'un alpha-beta
	// elle prend en parametre une solution trouvee jusqu'alors jusqu'a l'indice "n-indice+1",
	// solCour[0]: solution en Xn .. solCour[indice-1]: solution en Xn-indice+1
	// si indice==n (cas d'arret), c'est fini et elle se contente d'ajouter la solution
	// sinon, elle effectue la substitution a gcd[n-indice], puis resout en Xn-indice
	// elle lance alors solveRec(nouvelle_solution apres push_back,indice+1) sur chaque nvelle solution
	void solveRec(const std::vector<Gen>& solCour, int indice);

	// destructeur
	~ResolSystFp() {}

private:

	// l'ensemble des equations a satisfaire
	std::vector<PolPlusVarLex>* equations;

	// nombre d'equations
	int n;

	// le vecteur des solutions trouvees
	std::vector<solution> tabSol;

};

#endif
