/* calcul d'une base de Groebner */

#include "Fp.h"
#include "TermLex.h"
#include "PolPlusVarLex.h"
#include "DecodePolynome.h"
#include "AlgoClassiquesLex.h"
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

int main(int argc, char **argv) {
	vector<PolPlusVarLex> tabPol;
	AlgoClassiquesLex bdg;

	// test pour savoir si l'utilisateur a rentre un fichier ou des polynomes en ligne de commande
	ifstream file(argv[1]);
	if (file!=0) {
		// on lit dans un fichier
		tabPol=readFileLex(argv[1]);
	}
	else {
		// on lit la ligne de commande
		for (int i=1; i<argc; i++) {
			tabPol.push_back(str2PolLex(argv[i]));
		}
	}

	// on rajoute les indeterminees manquantes
	tabPol=normaliseLex(tabPol);

	bdg=AlgoClassiquesLex(tabPol);
	bdg.Buchberger();
	cout << endl << "Resultat pour l'algorithme de Buchberger basique (obtenu en " << bdg.getNbIter() << " iterations):" << endl;
	bdg.affiche();
	bdg=AlgoClassiquesLex(tabPol);
	bdg.BuchOpt();
	cout << "Resultat pour l'algorithme de Buchberger optimise (obtenu en " << bdg.getNbIter() << " iterations):" << endl;
	bdg.affiche();

	if (tabPol[0][0].getSize()==2) {
		cout << "Representation en escalier:" << std::endl;
		//bdg.escalier();
	}

	return 0;
	//system("PAUSE");
}
