/* compare deux ideaux donnes sous forme de polynomes genrateurs */

#include "Fp.h"
#include "TermGrevlex.h"
#include "PolPlusVarGrevlex.h"
#include "DecodePolynome.h"
#include "AlgoClassiquesGrevlex.h"
#include <iostream>
#include <vector>

using namespace std;

int main(int argc, char **argv) {
	vector<PolPlusVarGrevlex> tabPol1;
	vector<PolPlusVarGrevlex> tabPol2;

	// test pour savoir si l'utilisateur a rentre un fichier ou des polynomes en ligne de commande
	std::ifstream file(argv[1]);
	if (file!=0) {
		// on lit dans un fichier, une ligne vide separe les deux systemes de generateurs (sans polynome nul!)
		vector<PolPlusVarGrevlex> tabPol=readFileGrevlex(argv[1]);
		int i=1;
		for (;;i++) {
			if (tabPol[i].getSize()==0) {
				i++;
				break;
			}
			tabPol1.push_back(tabPol[i]);
		}
		for (;i<(int)tabPol.size();i++) tabPol2.push_back(tabPol[i]);
	}
	else {
		// on lit la ligne de commande
		int i=1;
		for (;;i++) {
			if (argv[i][0]==';') {
				i++;
				break;
			}
			tabPol1.push_back(str2PolGrevlex(argv[i]));
		}
		for (;i<argc;i++) tabPol2.push_back(str2PolGrevlex(argv[i]));
	}

	// on rajoute les indeterminees manquantes
	tabPol1=normaliseGrevlex(tabPol1);
	tabPol2=normaliseGrevlex(tabPol2);

	// test d'egalite des bases obtenues
	AlgoClassiquesGrevlex bdg1=AlgoClassiquesGrevlex(tabPol1);
	AlgoClassiquesGrevlex bdg2=AlgoClassiquesGrevlex(tabPol2);
	tabPol1=bdg1.BuchOpt();
	tabPol2=bdg2.BuchOpt();
	bool egalite[tabPol2.size()];
	for (int i=0; i<(int)tabPol2.size(); i++) egalite[i]=false;
	for (int i=(int)tabPol2.size()-1; i>=0; i--)
		for (int j=tabPol1.size()-1; j>=0; j--)
			if (tabPol2[j]==tabPol1[i]) {
				egalite[i]=true; // suffisant car il n'y a pas de redondances
				break;
			}

	for (int i=0; i<(int)tabPol1.size(); i++)
		if (!egalite[i]) {
			cout << endl << "Les ideaux ne sont pas egaux" << endl;
			return 0;
		}
	cout << endl << "Les ideaux sont egaux" << endl;

	return 0;
}
