/* test d'appartenance a un ideal */

#include "Fp.h"
#include "TermGrevlex.h"
#include "PolPlusVarGrevlex.h"
#include "DecodePolynome.h"
#include "AlgoClassiquesGrevlex.h"
#include <iostream>
#include <vector>

using namespace std;

int main(int argc, char **argv) {
	PolPlusVarGrevlex P;
	vector<PolPlusVarGrevlex> tabPol;

	// test pour savoir si l'utilisateur a rentre un fichier ou des polynomes en ligne de commande
	std::ifstream file(argv[1]);
	if (file!=0) {
		// on lit dans un fichier
		tabPol=readFileGrevlex(argv[1]);
		// mise au meme nb d'indeterminees
		tabPol=normaliseGrevlex(tabPol);
		// on extrait P
		P=PolPlusVarGrevlex(tabPol[0]);
		tabPol.erase(tabPol.begin(),tabPol.begin());
	}
	else {
		// on lit la ligne de commande
		for (int i=1; i<argc; i++) {
			tabPol.push_back(str2PolGrevlex(argv[i]));
		}
		// mise au meme nb d'indeterminees
		tabPol=normaliseGrevlex(tabPol);
		// on extrait P
		P=PolPlusVarGrevlex(tabPol[0]);
		tabPol.erase(tabPol.begin(),tabPol.begin());
	}

	AlgoClassiquesGrevlex bdg=AlgoClassiquesGrevlex(tabPol);
	if ((P.reduction(bdg.BuchOpt())).getSize()==0) {
		cout << endl << P << " est dans l'ideal engendre par les polynomes:" << endl;
		for (int i=0; i<(int)tabPol.size(); i++) cout << tabPol[i] << endl;
	}
	else {
		cout << endl << P << " n'est pas dans l'ideal engendre par les polynomes:" << endl;
		for (int i=0; i<(int)tabPol.size(); i++) cout << tabPol[i] << endl;
	}

	return 0;
}
