/* resolution d'un systeme polynomial */

#include "Fp.h"
#include "TermLex.h"
#include "PolPlusVarLex.h"
#include "DecodePolynome.h"
#include "AlgoClassiquesLex.h"
#include "ResolSystFp.h"
#include <vector>
#include <iostream>
#include <fstream>

using namespace std;

int main(int argc, char **argv) {
	vector<PolPlusVarLex> tabPol;
	AlgoClassiquesLex bdg;

	// test pour savoir si l'utilisateur a rentre un fichier ou des polynomes en ligne de commande
	std::ifstream file(argv[1]);
	if (file!=0) {
		// on lit dans un fichier
		tabPol=readFileLex(argv[1]);
	}
	else {
		// on lit la ligne de commande
		for (int i=1; i<argc; i++) {
			tabPol.push_back(str2PolLex(argv[i]));
		}
	}

	// on rajoute les indeterminees manquantes
	tabPol=normaliseLex(tabPol);

	// mise sous forme echelonnee
	bdg=AlgoClassiquesLex(tabPol);
	tabPol=bdg.BuchOpt();

	// stockage des differents groupes de polynomes
	// il doit y en avoir autant qu'il y a d'indeterminees dans tabPol
	int n=tabPol[0][0].getSize(),min;
	vector<PolPlusVarLex> groupesPol[n];
	for (int i=0; i<(int)tabPol.size(); i++) {
		// recuperation des polynomes ne faisant intervenir que Xu..Xn pour un certain u
		// on se souvient du plus petit indice rencontre pour savoir ou placer le polynome
		// remarque: si la base est ordonnee, on peut raffiner
		min=n; // aussi pour verifier s'il y a une constante, auquel cas le resultat est immediat
		for (int j=tabPol[i].getSize()-1; j>=0; j--)
		for (int k=n-1; k>=0; k--) if (min>k && tabPol[i][j][k]!=0) min=k;
		if (min==n) {
			std::cout << "Pas de solutions" << std::endl;
			return 0;
		}
		groupesPol[min].push_back(tabPol[i]);
	}

	// verification des etages de l'escalier [si on ne souhaite que les
	// solutions isolees]
	for (int i=n-1; i>=0; i--)
		if (groupesPol[i].empty()) {
			std::cout << "Existence de solutions non isolees" << std::endl;
			return 0;
		}

	// on resout
	ResolSystFp resolution=ResolSystFp(groupesPol);
	resolution.solve();
	resolution.affiche();

	return 0;
	//system("PAUSE");
}
